import { ContextTracker, ExternalTokenizer, LRParser, LocalTokenGroup } from '@lezer/lr';
import { LRLanguage, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';
import { completeFromList } from '@codemirror/autocomplete';
import { data } from '../output.js';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const newline = 59, ignoredNewline = 60, Ident = 1, FnIdent = 2, DollarIdent = 3, Comma = 16, LBracket = 25, RBracket = 26, LParen = 27, RParen = 28, LBrace = 43, RBrace = 45;

class MyContext {
    constructor(parent, data) {
        this.parent = parent !== null && parent !== void 0 ? parent : this;
        this.data = data;
    }
    ignoreNewlines(value) {
        return new MyContext(this, Object.assign(Object.assign({}, this.data), { ignoreNewlines: value }));
    }
    justHadComma(value) {
        return new MyContext(this.parent, Object.assign(Object.assign({}, this.data), { justHadComma: value }));
    }
}
const startContext = new MyContext(null, { ignoreNewlines: false, justHadComma: false });
const context = new ContextTracker({
    start: startContext,
    reduce(context, term, stack, input) {
        return context;
    },
    shift(context, term, stack, input) {
        context = context.justHadComma(term === Comma);
        if (term === LParen || term == LBracket) {
            return context.ignoreNewlines(true);
        }
        if (term === LBrace) {
            return context.ignoreNewlines(false);
        }
        if (term === RParen || term == RBrace || term == RBracket) {
            return context.parent;
        }
        return context;
    }
});
function code(x) {
    return x.charCodeAt(0);
}
const newlines = new ExternalTokenizer((input, stack) => {
    let ctx = stack.context.data;
    if (input.next == code("\n")) {
        let ignore = ctx.ignoreNewlines || ctx.justHadComma;
        input.acceptToken(ignore ? ignoredNewline : newline, 1);
        return;
    }
}, { contextual: true });
const identifiers = new ExternalTokenizer((input, stack) => {
    const a = code("a");
    const z = code("z");
    const A = code("A");
    const Z = code("Z");
    const u = code("_");
    const n0 = code("0");
    const n9 = code("9");
    const first = (n) => (a <= n && n <= z) || (A <= n && n <= Z) || (n == u);
    const rest = (n) => first(n) || (n0 <= n && n <= n9);
    let token = Ident;
    if (!first(input.peek(0))) {
        if (input.peek(0) != code("$")) {
            return;
        }
        token = DollarIdent;
    }
    let n = 1;
    while (rest(input.peek(n))) {
        n += 1;
    }
    if (input.peek(n) == code("(")) {
        token = FnIdent;
    }
    input.acceptToken(token, n);
});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_Ident = {__proto__:null,and:58, else:60, false:62, if:64, in:66, let:68, match:70, meta:72, not:74, null:76, or:78, this:80, true:82};
const parser = LRParser.deserialize({
  version: 14,
  states: "*OQ`Q]OOPtOPOOOOQ['#Db'#DbO`Q]O'#DpOOQ['#Cc'#CcO$lQ]O'#CeO$sQ]O'#CdO'cQTO'#D_OOQS'#Dr'#DrO'hQTO'#DpO'vQ]O'#DpQOQTOOO$sQ]O'#DrP(XO`O'#CaPOOO)C?a)C?aOOQ[-E7`-E7`O(aQTO,5:[O'vQ]O,5:[O(oQ]O,59zOOQ['#Dt'#DtO(zQ]O'#DWO)ROQO'#D]OOQ['#Ds'#DsO+vQ]O'#DsOOQ['#Dc'#DcO.aQ]O'#CfOOQS,59O,59OOOQ['#Du'#DuO$sQ]O,59yO.qQ]O'#DgO(aQTO,5:[O'vQ]O,5:[OOQS,5:^,5:^POOO'#Da'#DaP/]O`O,58{POOO,58{,58{O/eQTO1G/vO'vQ]O1G/vO/eQTO1G/vOOQ['#Df'#DfO/sQ]O1G/fO0OQ]O,59rO0VQ]O,59rO0^QTO,59vOOOO'#De'#DeO0cOQO,59wOOQ[,59w,59wOOQ['#Dd'#DdO0nQ]O'#DYOOQ['#DY'#DYOOQ[,5:_,5:_OOQ[-E7a-E7aOOQS1G/e1G/eOOQS,5:R,5:ROOQS-E7e-E7ePOOO-E7_-E7_POOO1G.g1G.gO0uQTO7+%bO0uQTO7+%bOOQ[-E7d-E7dO1TQ]O1G/^OOQ[1G/^1G/^OOQ[1G/b1G/bOOOO-E7c-E7cOOQ[1G/c1G/cOOQ[-E7b-E7bOOQ[,59t,59tO1[QTO<<H|OOQ[7+$x7+$x",
  stateData: "1m~O!`OS!^OSSOS!aPQ~OPTOp[Or[Os[O!]QO!eSO~O!a]O~ObbOPXXQXXRXXZXX[XX]XX^XX_XX`XXaXXa!SXbXXcXXdXXeXXfXXgXXhXXiXXjXXkXXlXXmXXnXXoXXpXXqXXrXXsXXtXXuXXvXXwXXxXXyXX{XX!]XX!eXX!jXX}XX~O![XX~PyOPfOQfORfOZfO[cO]cO^cO_cO`cOacObcOccOdcOecOfcOgcOhcOicOjcOkcOlcOmkOnkOokOpkOqkOrkOskOtkOukOvkOwkOxkOykO{dO!jeO![YP!]YP!eYP}YP~OalO~O!]mO!eSO![!dX}!dX~OPTOp[Or[Os[O!]QO~O!bqO!csO~O!]mO!eSO![!da}!da~OPwObwOa!Sa~OPzO~PcO!Q|O!j!OO!k|O~OPfOQfORfOZfO[cO]cO^cO_cO`cOacObcOccOdcOecOfcOgcOhcOicOjcOkcOlcOmkOnkOokOpkOqkOrkOskOtkOukOvkOwkOxkOykO{dO!]!PO!eSO!jeO~O}!RO~P)^OPfOQfORfOZfO[cO]cO^cO_cO`cOacObcOccOdcOecOfcOgcOhcOicOjcOkcOlcOmkOnkOokOpkOqkOrkOskOtkOukOvkOwkOxkOykO{dO!jeO~O![YX!]YX!eYX}YX~P+}OPTOp[Or[Os[O![!ZX!]!ZX!e!ZX}!ZX~O!bqO!c!YO~O!]mO!eSO![!di}!di~OPwObwOa!Si~OP!^O~PcOd!_O~PyO}!`O~O!Q|O!j!bO!k|O~O}!dO~P)^O!]mO!eSO![!dq}!dq~Od!fO~PyO!]mO!eSO![!dy}!dy~OS_~",
  goto: "&p!jPPPPP!kP!n#U#a#lPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP#uP#}P$Q$QP#U$Y$e$k$}%V%]%c%iPPPPPPPP%{P&R&f$Q$QR^PSYOdSaRy`mX`ntv!Z![!eT!Pg!QcWORYadmouycUORYadmouyQjUQp[R!Ul]gU[gil!QR!Sg]fU[gil!QcVORYadmouyQr]R!XrQROW_RouyQoYQuaRydUiU[lR!TiQ!QgR!c!QQ}eR!a}QxbR!]xQnXQt`W!Wnt![!eQ![vR!e!ZQZOR{dSXOdU`RYySvaoQ!VmR!ZuWhU[ilT!Pg!Q",
  nodeNames: "⚠ Ident FnIdent DollarIdent LineComment BlockComment Pipeline Pipe OpStmt OpName Soup Scalar + - * / , = . ' : ! ? < > [ ] ( ) and else false if in let match meta not null or this true RecordStart { RecordRest } PipeExpr String StringEsc AssignStmt UnExpr",
  maxTerm: 73,
  context: context,
  skippedNodes: [0,4,5,51],
  repeatNodeCount: 7,
  tokenData: "4u~RtOX#cXY#}Y[#c[]#}]p#cpq#}qr%frs%|sw#cwx&Rxy&iyz'Pz{'g{|'}|}(e}!O({!O!P)c!P!Q)y!Q![,o![!].u!]!^#c!^!_/]!_!`/s!`!a0Z!a!b0q!b!}#c!}#O1X#O#P1o#P#Q2y#Q#o#c#o#p3a#p#q3w#q#r4_#r;'S#c;'S;=`#w<%lO#cS#hT!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cS#zP;=`<%l#cU$U[!`Q!kSOX#cXY#}Y[#c[]#}]p#cpq#}qr#cs#O#c#O#P$z#P;'S#c;'S;=`#w<%lO#cQ$}QYZ%T]^%TQ%YS!`QXY%T[]%Tpq%T#O#P$zU%mTeQ!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#c~&RO!j~U&YTcQ!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU&pTkQ!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU'WTlQ!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU'nT^Q!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU(UT[Q!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU(lT`Q!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU)ST]Q!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU)jTbQ!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU*QX!kS_QOr#csz#cz{*m{!P#c!P!Q+T!Q#O#c#P;'S#c;'S;=`#w<%lO#cU*tT!aQ!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU+[Z!kSSQOY+TYZ#cZ]+T]^#c^r+Trs+}s#O+T#O#P+}#P;'S+T;'S;=`,i<%lO+TQ,STSQOY+}Z]+}^;'S+};'S;=`,c<%lO+}Q,fP;=`<%l+}U,lP;=`<%l+TU,v_ZQ!kSOr#cs!O#c!O!P,o!P!Q#c!Q![,o![!c#c!c!}-u!}#O#c#P#R#c#R#S,o#S#T#c#T#o-u#o;'S#c;'S;=`#w<%lO#cU-|]ZQ!kSOr#cs!Q#c!Q![-u![!c#c!c!}-u!}#O#c#P#R#c#R#S-u#S#T#c#T#o-u#o;'S#c;'S;=`#w<%lO#cU.|TdQ!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU/dTgQ!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU/zTaQ!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU0bThQ!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU0xTfQ!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU1`TiQ!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU1rVOY2XYZ2^Z]2X]^2^^;'S2X;'S;=`2q;=`O2XS2^O!QSU2eS!QS!`QXY%T[]%Tpq%T#O#P$zS2vP!QS;=`<%l2XU3QTjQ!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU3hT{Q!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU4OT!eQ!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#cU4fT}Q!kSOr#cs#O#c#P;'S#c;'S;=`#w<%lO#c",
  tokenizers: [1, 2, newlines, identifiers, new LocalTokenGroup("b~RPz{U~XP!P!Q[~aO!c~~", 17, 64)],
  topRules: {"Pipeline":[0,6]},
  dynamicPrecedences: {"42":2,"49":1},
  specialized: [{term: 1, get: (value) => spec_Ident[value] || -1}],
  tokenPrec: 762
});

const TenzirQueryLang = LRLanguage.define({
    parser: parser.configure({
        props: [
            styleTags({
                "Scalar true false null DollarIdent": tags.literal,
                "String": tags.string,
                "StringEsc and else if in let match meta not or this": tags.keyword,
                "OpName! FnIdent": tags.name,
                "+ - \"*\" \"/\" = . ' : \"!\" < > \"?\" \"|\"": tags.punctuation,
                "LineComment BlockComment": tags.comment,
            }),
        ],
        // TODO: add folding later
    }),
});
const getCompletion = (completion) => {
    return {
        label: completion.label,
        type: completion.type,
        detail: completion.detail,
        info: () => {
            const node = document.createElement("div");
            const div = document.createElement("div");
            div.className = "custom-completioninfoHeader";
            div.innerHTML = `<div><a class="custom-docLink" href="${completion.docLink}" target="_blank"><span>${completion.label}</span><div class="custom-icon"></div></a></div>`;
            node.insertAdjacentElement("afterbegin", div);
            node.innerHTML += completion.processedHTML;
            return node;
        },
    };
};
const tqlCompletionList = data.map((completion) => getCompletion(completion));
const tqlCompletion = TenzirQueryLang.data.of({
    autocomplete: completeFromList(tqlCompletionList),
});
function TQL() {
    return new LanguageSupport(TenzirQueryLang, [tqlCompletion]);
}

export { TQL, TenzirQueryLang, tqlCompletion };
